#!/usr/bin/python 

# this program merge relations using Timegraph 
## usage: python merge-relations/merge-relations.py input_file output_file 
## input: relations in tabbed format
## filename, entity1, entity2, relation, comment, weight 
## output: 

import sys 
import os 
import re
debug = 1 

def get_arg (index):
    if debug >= 2: 
        print sys.argv[index]
    return sys.argv[index]

def extract_name(filename):
    parts = re.split('/', filename)
    length = len(parts)
    return parts[length-1]

basedir = re.sub('merge-relations.py', '', get_arg(0)) 

cmd_folder = os.path.dirname(basedir)
if cmd_folder not in sys.path:
    sys.path.insert(0, cmd_folder)
import relation_to_timegraph



input = get_arg(1)
output = get_arg(2) 
name = extract_name(input) 
tmp_output = basedir+'timegraph_input/'+name  
# sort relations according to weight and in the same weight level, consider neighbors first 
command = 'python '+basedir+'sort-with-weight.py '+ input + ' '+tmp_output 
os.system(command)

timegraph_input = open(tmp_output) 
timegraph_text = timegraph_input.read() 

tg = relation_to_timegraph.Timegraph() 
tg = relation_to_timegraph.create_timegraph_from_weight_sorted_relations(timegraph_text, tg) 

output_file = open(output, 'w') 
#output_file.write(tg.final_relations+tg.violated_relations+'\n') 
output_file.write(tg.final_relations+'\n') 
output_file.close() 

timegraph_input.close() 
