package timemlmerger;

import java.io.*;
import utils_bk.FileUtils;

/**
 * Tokenizer.java
 * @author Hector Llorens
 * Created on Oct 27, 2011
 */
public class LinkMerger {

    private static String program_path = FileUtils.getApplicationPath() + "program-data"+File.separator;
    private static String program_bin = program_path + "merge-relations"+File.separator+"merge-relations.py";
    private static String program_bin_inconsistent = program_path + "merge-relations"+File.separator+"merge-relations-inconsistent.py";


    /**
     * Runs the tokenizer over a file and saves file in .tok
     *
     * @param filename
     * @return Output filename
     */
    public static String run(String filename, String option) {
        if(option.equals("inconsistent")){
            execute_inconsistent(filename, filename + "-merged");
        }else{
            execute(filename, filename + "-merged");
        }
        return filename + "-merged";
    }

    private static void execute(String filename, String outputfile) {
        try {
            String[] command = {"/bin/sh", "-c","python \""+program_bin+"\" \"" + filename +"\" \""+outputfile+"\""};
            Process p=null;
            try {
            p = Runtime.getRuntime().exec(command);
            p.waitFor();
            } finally {
                if(p!=null){
                    p.getInputStream().close();
                    p.getOutputStream().close();
                    p.getErrorStream().close();
                    p.destroy();
                }
            }
        } catch (Exception e) {
            System.err.println("Errors found (TreeTagger):\n\t" + e.toString());
            if (System.getProperty("DEBUG") != null && System.getProperty("DEBUG").equalsIgnoreCase("true")) {
                e.printStackTrace(System.err);
                System.exit(1);
            }

        }
    }


    private static void execute_inconsistent(String filename, String outputfile) {
        try {
            String[] command = {"/bin/sh", "-c","python "+program_bin_inconsistent+" \"" + filename +"\" \""+outputfile+"\""};
            Process p=null;
            try {
            p = Runtime.getRuntime().exec(command);
            p.waitFor();
            } finally {
                if(p!=null){
                    p.getInputStream().close();
                    p.getOutputStream().close();
                    p.getErrorStream().close();
                    p.destroy();
                }
            }
        } catch (Exception e) {
            System.err.println("Errors found (TreeTagger):\n\t" + e.toString());
            if (System.getProperty("DEBUG") != null && System.getProperty("DEBUG").equalsIgnoreCase("true")) {
                e.printStackTrace(System.err);
                System.exit(1);
            }

        }
    }









}
