#!/bin/bash
# Script for renaming extensions

# set line separator
IFS="
"

foldspath="/home/hector/Desktop/merging-folds/"
toolpath="/home/hector/Dropbox/TimeML-BasicKit/TempEval-3/TempEval-tools/"

function evaluate {
	echo -e "\n\n>> $1 fold$2 ----------------------------------------"
	echo -e "\n\n>> $1 fold$2 ----------------------------------------">&2
	${toolpath}evaluation-relations/temporal_evaluation.py "${foldspath}fold$2/test-fold$i-normalized-timex-ref-links" "${foldspath}fold$2/$1-fold$i-normalized-timex-ref-links" 0 > outputxxx;cat outputxxx;cat outputxxx >&2; rm outputxxx
	if [ $? -ne 0 ];then exit 1; fi
	${toolpath}evaluation-entities/evaluate_entities.py "${foldspath}fold$2/test-fold$i-normalized" "${foldspath}fold$2/$1-fold$i-normalized" -2> outputxxx;cat outputxxx;cat outputxxx >&2; rm outputxxx
	if [ $? -ne 0 ];then exit 1; fi
}


for i in {3..10}
do
	echo -e "\n\n### fold$i ----------------------------------------"
	echo -e "\n\n### fold$i ----------------------------------------">&2

	# clean previous experiments
	rm -rf "${foldspath}fold${i}/"*-fold${i}-*
	rm -rf "${foldspath}fold${i}/"bottom*-fold${i}*
	rm -rf "${foldspath}fold${i}/"top*-fold${i}*

	# run merged experiments

	# baseline <<comment
	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/bottom-up-union-fold$i" -s bottom-up -et 0.0 -lt 0.0 >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/bottom-up-intersection-fold$i" -s bottom-up -et 0.8 -lt 0.8 >&2
	if [ $? -ne 0 ];then exit 1; fi

	#java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/bottom-up-majority-fold$i" -s bottom-up -et 0.501 -lt 0.501 >&2
	#if [ $? -ne 0 ];then exit 1; fi



	# bottom-up
	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/bottom-up-111-ignore-fold$i" -s bottom-up >&2
	if [ $? -ne 0 ];then exit 1; fi

#	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i;${foldspath}fold${i}/trips-fold$i" -o "${foldspath}fold${i}/bottom-up-per-fold$i" -s bottom-up -w "0.31;0.29;0.27;0.26" >&2
#	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/bottom-up-per-ignore-fold$i" -s bottom-up -w "0.31;0.29;0.27" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/bottom-up-per-best-fold$i" -s bottom-up -w "0.31;0.27;0.27" >&2
	if [ $? -ne 0 ];then exit 1; fi



	# top down
	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/top-down-union-fold$i" -s top-down  -et 0.0 -lt 0.0  >&2
	if [ $? -ne 0 ];then exit 1; fi


	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/top-down-111-ignore-fold$i" -s top-down >&2
	if [ $? -ne 0 ];then exit 1; fi

#	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i;${foldspath}fold${i}/trips-fold$i" -o "${foldspath}fold${i}/top-down-per-fold$i" -s top-down -w "0.31;0.29;0.27;0.26" >&2
#	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/top-down-per-ignore-fold$i" -s top-down -w "0.31;0.29;0.27" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/top-down-per-best-fold$i" -s top-down -w "0.31;0.27;0.27" >&2
	if [ $? -ne 0 ];then exit 1; fi
	#comment
	# normalize test, systems, and mergings # ${foldspath}fold${i}/trips-fold$i;${foldspath}fold${i}/bottom-up-majority-fold$i;
	java -jar "${toolpath}TimeML-Normalizer/TimeML-Normalizer.jar" -a "${foldspath}fold${i}/test-fold$i;${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i;${foldspath}fold${i}/bottom-up-union-fold$i;${foldspath}fold${i}/bottom-up-intersection-fold$i;${foldspath}fold${i}/bottom-up-111-ignore-fold$i;${foldspath}fold${i}/bottom-up-per-ignore-fold$i;${foldspath}fold${i}/bottom-up-per-best-fold$i;${foldspath}fold${i}/top-down-union-fold$i;${foldspath}fold${i}/top-down-111-ignore-fold$i;${foldspath}fold${i}/top-down-per-ignore-fold$i;${foldspath}fold${i}/top-down-per-best-fold$i" >&2
	if [ $? -ne 0 ];then exit 1; fi

	# add links to test, systems, and mergings
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/test-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/TIPSem-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/TIPSemB-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/trios-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
#	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/trips-fold$i-normalized" >&2
#	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/bottom-up-union-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/bottom-up-intersection-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
#	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/bottom-up-majority-fold$i-normalized" >&2
#	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/bottom-up-111-ignore-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
#	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/bottom-up-per-fold$i-normalized" >&2
#	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/bottom-up-per-ignore-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/bottom-up-per-best-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/top-down-union-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/top-down-111-ignore-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
#	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/top-down-per-fold$i-normalized" >&2
#	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/top-down-per-ignore-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/top-down-per-best-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi


	# evaluate links and entities for systems and mergings

	evaluate "TIPSem" $i;
	evaluate "TIPSemB" $i;
	evaluate "trios" $i;
#	evaluate "trips" $i;

	evaluate "bottom-up-union" $i;
	evaluate "bottom-up-intersection" $i;
#	evaluate "bottom-up-majority" $i;

	evaluate "bottom-up-111-ignore" $i;
#	evaluate "bottom-up-per" $i;
	evaluate "bottom-up-per-ignore" $i;
	evaluate "bottom-up-per-best" $i;

	evaluate "top-down-union" $i;
	evaluate "top-down-111-ignore" $i;
#	evaluate "top-down-per" $i;
	evaluate "top-down-per-ignore" $i;
	evaluate "top-down-per-best" $i;

done




# useful parsing command
#cat perico.txt | sed "s/^[[:blank:]]*//g" | cut -f 1-4 | grep "^[0-9D]" | tr "\n" " " | sed "s/[!][[:blank:]]*/\n/g" | sed "s/ Done.*$//" | tr " " "\t"





