#!/bin/bash
# Script for renaming extensions

# set line separator
IFS="
"

foldspath="/home/hector/Desktop/merging-folds/"
toolpath="/home/hector/Dropbox/TimeML-BasicKit/TempEval-3/TempEval-tools/"

function evaluate {
	echo -e "\n\n>> $1 fold$2 ----------------------------------------"
	echo -e "\n\n>> $1 fold$2 ----------------------------------------">&2
	${toolpath}evaluation-relations/temporal_evaluation.py "${foldspath}fold$2/test-fold$i-normalized-timex-ref-links" "${foldspath}fold$2/$1-fold$i-normalized-timex-ref-links" 0 > outputxxx;cat outputxxx;cat outputxxx >&2; rm outputxxx
	if [ $? -ne 0 ];then exit 1; fi
	${toolpath}evaluation-entities/evaluate_entities.py "${foldspath}fold$2/test-fold$i-normalized" "${foldspath}fold$2/$1-fold$i-normalized" -2> outputxxx;cat outputxxx;cat outputxxx >&2; rm outputxxx
	if [ $? -ne 0 ];then exit 1; fi
}


for i in {1..10}
do
	echo -e "\n\n### fold$i ----------------------------------------"
	echo -e "\n\n### fold$i ----------------------------------------">&2

	# clean previous experiments
	rm -rf "${foldspath}fold${i}/"*-fold${i}-*
	rm -rf "${foldspath}fold${i}/"bottom*-fold${i}*
	rm -rf "${foldspath}fold${i}/"top*-fold${i}*
	rm -rf "${foldspath}fold${i}/"TD*-fold${i}*

	# run merged experiments

	# top down
	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/TD-BEST-TIPSemTRIOS-fold$i" -s top-down -w "0.31;0.27"  >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i" -o "${foldspath}fold${i}/TD-BEST-TIPSemTIPSemB-fold$i" -s top-down -w "0.31;0.29"  >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/TD-BEST-TIPSemBTRIOS-fold$i" -s top-down -w "0.29;0.27"  >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i;${foldspath}fold${i}/trips-fold$i" -o "${foldspath}fold${i}/top-down-per-fold$i" -s top-down -w "0.31;0.29;0.27;0.26" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/TD-BEST-inconsistent-fold$i" -s top-down -lmo inconsistent -w "0.31;0.27;0.27" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/TD-superBEST-fold$i" -s top-down -w "0.31;0.27;0.27" -et 0.29 >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/top-down-samethresh-fold$i" -s top-down -w "0.31;0.27;0.27" -et 0.27 >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/bottom-up-samethresh-fold$i" -s bottom-up -w "0.31;0.27;0.27" -et 0.27 >&2
	if [ $? -ne 0 ];then exit 1; fi


	# normalize test, systems, and mergings # ${foldspath}fold${i}/trips-fold$i;${foldspath}fold${i}/bottom-up-majority-fold$i;
	java -jar "${toolpath}TimeML-Normalizer/TimeML-Normalizer.jar" -a "${foldspath}fold${i}/test-fold$i;${foldspath}fold${i}/TD-BEST-TIPSemTRIOS-fold$i;${foldspath}fold${i}/TD-BEST-TIPSemTIPSemB-fold$i;${foldspath}fold${i}/TD-BEST-TIPSemBTRIOS-fold$i;${foldspath}fold${i}/top-down-per-fold$i;${foldspath}fold${i}/TD-BEST-inconsistent-fold$i;${foldspath}fold${i}/TD-superBEST-fold$i;${foldspath}fold${i}/top-down-samethresh-fold$i;${foldspath}fold${i}/bottom-up-samethresh-fold$i" >&2
	if [ $? -ne 0 ];then exit 1; fi

	# add links to test, systems, and mergings
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/test-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/TD-BEST-TIPSemTRIOS-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/TD-BEST-TIPSemTIPSemB-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/TD-BEST-TIPSemBTRIOS-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/top-down-per-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/TD-BEST-inconsistent-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/TD-superBEST-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/top-down-samethresh-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/bottom-up-samethresh-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi


	# evaluate links and entities for systems and mergings

#	evaluate "TIPSem" $i;
#	evaluate "TIPSemB" $i;
#	evaluate "trios" $i;
#	evaluate "trips" $i;

	evaluate "TD-BEST-TIPSemTRIOS" $i;
	evaluate "TD-BEST-TIPSemTIPSemB" $i;
	evaluate "TD-BEST-TIPSemBTRIOS" $i;
	evaluate "top-down-per" $i;
	evaluate "TD-BEST-inconsistent" $i;
	evaluate "TD-superBEST" $i;
	evaluate "top-down-samethresh" $i;
	evaluate "bottom-up-samethresh" $i;

done




# useful parsing command
#cat perico.txt | sed "s/^[[:blank:]]*//g" | cut -f 1-4 | grep "^[0-9D]" | tr "\n" " " | sed "s/[!][[:blank:]]*/\n/g" | sed "s/ Done.*$//" | tr " " "\t"





