#!/bin/bash
# Script for renaming extensions

# set line separator
IFS="
"

foldspath="/home/hector/Desktop/merging-folds/"
toolpath="/home/hector/Dropbox/TimeML-BasicKit/TempEval-3/TempEval-tools/"

function evaluate {
	echo -e "\n\n>> $1 fold$2 ----------------------------------------"
	echo -e "\n\n>> $1 fold$2 ----------------------------------------">&2
	${toolpath}evaluation-relations/temporal_evaluation.py "${foldspath}fold$2/test-fold$2-normalized-timex-ref-links" "${foldspath}fold$2/$1-fold$2-normalized-timex-ref-links" 0 > outputxxx;cat outputxxx;cat outputxxx >&2; rm outputxxx
	if [ $? -ne 0 ];then exit 1; fi
	${toolpath}evaluation-entities/evaluate_entities.py "${foldspath}fold$2/test-fold$2-normalized" "${foldspath}fold$2/$1-fold$2-normalized" -2> outputxxx;cat outputxxx;cat outputxxx >&2; rm outputxxx
	if [ $? -ne 0 ];then exit 1; fi
}


for i in {1..10}
do
	echo -e "\n\n### fold$i ----------------------------------------"
	echo -e "\n\n### fold$i ----------------------------------------">&2

	# clean previous experiments
	rm -rf "${foldspath}fold${i}/"*-fold${i}-*
	rm -rf "${foldspath}fold${i}/"bottom*-fold${i}*
	rm -rf "${foldspath}fold${i}/"top*-fold${i}*
	rm -rf "${foldspath}fold${i}/"TD*-fold${i}*
	rm -rf "${foldspath}fold${i}/"BU*-fold${i}*

	# run merged experiments
	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/BU-BEST-inconsistent-fold$i" -s bottom-up -lmo inconsistent -w "0.31;0.27;0.27" -et 0.32 >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/BU-111-fold$i" -s bottom-up -w "1;1;1" -et 0.35 >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/BU-PERF-fold$i" -s bottom-up  -w "0.31;0.29;0.27" -et 0.32  >&2
	if [ $? -ne 0 ];then exit 1; fi
	java -jar "${toolpath}TimeML-Merger/TimeML-Merger.jar" -a "${foldspath}fold${i}/TIPSem-fold$i;${foldspath}fold${i}/TIPSemB-fold$i;${foldspath}fold${i}/trios-fold$i" -o "${foldspath}fold${i}/BU-BEST-fold$i" -s bottom-up -w "0.31;0.27;0.27" -et 0.32 >&2
	if [ $? -ne 0 ];then exit 1; fi


	# normalize test, systems, and mergings # ${foldspath}fold${i}/trips-fold$i;${foldspath}fold${i}/bottom-up-majority-fold$i;
	java -jar "${toolpath}TimeML-Normalizer/TimeML-Normalizer.jar" -a "${foldspath}fold${i}/test-fold$i;${foldspath}fold${i}/BU-BEST-inconsistent-fold$i;${foldspath}fold${i}/BU-BEST-fold$i;${foldspath}fold${i}/BU-111-fold$i;${foldspath}fold${i}/BU-PERF-fold$i" >&2
	if [ $? -ne 0 ];then exit 1; fi

	# add links to test, systems, and mergings

	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/test-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/BU-BEST-inconsistent-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/BU-111-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/BU-PERF-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi

	java -jar "${toolpath}TimeML-Add-timex-ref-links/TimeML-Add-timex-ref-links.jar" "${foldspath}fold${i}/BU-BEST-fold$i-normalized" >&2
	if [ $? -ne 0 ];then exit 1; fi



	# evaluate links and entities for systems and mergings

	evaluate "BU-BEST-inconsistent" $i;
	evaluate "BU-111" $i;
	evaluate "BU-PERF" $i;
	evaluate "BU-BEST" $i;

done




# useful parsing command
#cat perico.txt | sed "s/^[[:blank:]]*//g" | cut -f 1-4 | grep "^[0-9D]" | tr "\n" " " | sed "s/[!][[:blank:]]*/\n/g" | sed "s/ Done.*$//" | tr " " "\t"





