package timemladdtimexreflinks;

import TimeML_BasicKit.TML_file_utils;
import java.io.*;
import java.util.*;

import nlp_files.*;
import utils_bk.*;

/**
 *
 * @author Hector Llorens
 * @since 2011
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        ArrayList<File> filelist = new ArrayList<File>();
        //System.setProperty("DEBUG", "true");

        try {
            if (args.length != 1) {
                System.err.println("At least one argument required: tml file or dir containing files.");
                System.exit(0);
            }
            File f = new File(args[0]);
            if (!f.exists()) {
                throw new Exception("File does not exist: " + args[0]);
            }
            if (f.isFile()) {
                XMLFile xmlfile = new XMLFile();
                xmlfile.loadFile(f);
                xmlfile.overrideExtension("tml-min-consistency");
                if (!xmlfile.isWellFormed()) {
                    throw new Exception("File: " + xmlfile.getFile().getCanonicalPath() + " is not a valid TimeML XML file.");
                }
                // crear el directori de eixida i processar tots els fitxers i renombrarlos al directori d'eixida
                    File ftdir = new File(f.getCanonicalPath() + "-timex-ref-links");
                    if (ftdir.exists()) {
                        FileUtils.deleteRecursively(ftdir);
                    }
                    if (!ftdir.mkdirs()) {  // mkdirs creates many parent dirs if needed
                        throw new Exception("Directory not created...");
                    }
                    String output=TML_file_utils.TML_add_tref_tref_links(f.getCanonicalPath());
                    (new File(output)).renameTo(new File(ftdir + File.separator + f.getName()));
            } else {
                File[] files = f.listFiles(FileUtils.onlyFilesFilter);
                if (files.length == 0) {
                    throw new Exception("Empty folder: " + f.getName());
                }
                for (int fn = 0; fn < files.length; fn++) {
                    XMLFile xmlfile = new XMLFile();
                    xmlfile.loadFile(files[fn]);
                    xmlfile.overrideExtension("tml-min-consistency");
                    if (!xmlfile.isWellFormed()) {
                        throw new Exception("File: " + xmlfile.getFile().getCanonicalPath() + " is not a valid TimeML XML file.");
                    }
                    filelist.add(files[fn]);
                }
                // crear el directori de eixida i processar tots els fitxers i renombrarlos al directori d'eixida
                 File ftdir = new File(f.getCanonicalPath() + "-timex-ref-links");
                if (ftdir.exists()) {
                    FileUtils.deleteRecursively(ftdir);
                }
                if (!ftdir.mkdirs()) {  // mkdirs creates many parent dirs if needed
                    throw new Exception("Directory not created...");
                }
                 for(int i=0;i<filelist.size();i++){
                    String output=TML_file_utils.TML_add_tref_tref_links(filelist.get(i).getCanonicalPath());
                    (new File(output)).renameTo(new File(ftdir + File.separator + filelist.get(i).getName()));
                 }

            }

        } catch (Exception e) {
            System.err.println("Errors found:\n\t" + e.getMessage() + "\n");
            if (System.getProperty("DEBUG") != null && System.getProperty("DEBUG").equalsIgnoreCase("true")) {
                e.printStackTrace(System.err);
            }
            System.exit(1);
        }

    }
}
