# this program sorts with weight 

#python 24-d-sort-with-weight/code/sort-with-weight.py filename 
#foreach f (23-main-events/data/*); do
#python 24-d-sort-with-weight/code/sort-with-weight.py $f                      
#done

import re
import sys
import operator 

def get_arg (index):
    #for arg in sys.argv:
#    print sys.argv[index]
    return sys.argv[index]

debug = -1

def extract_name(filename):
    parts = re.split('/', filename)
    length = len(parts)
    return parts[length-1]

if len(sys.argv) == 2: 
    ## local 
    filename = get_arg(1)
    name = extract_name(filename) 
    basedir = re.sub(name, '', filename) + '../../'
    input = '24-c-get-weights-4-relations/data/'+name
    output = '24-d-sort-with-weight/data/'+name
elif len(sys.argv) > 2: 
    ## package 
    input = get_arg(1) 
    output = get_arg(2) 
    name = extract_name(input) 


weight_for_relation = open(input).read() 
sorted_weight = open(output, 'w') 

entity_considered = '' 
relations_considered = ''

equal_count = 0 

def get_entities(line): 
    words = line.split('\t') 
    return words[1], words[2] 

def get_entity_count(entities): 
    entity2count = {} 
    entity2line = {} 
    global equal_count
    for line in entities.split('\n'): 
        if line.strip() == '': 
            continue 
        e1, e2 = get_entities(line) 
        if e1 == e2: 
            equal_count += 1
            continue 
        if debug >= 2: 
            print line 
            print e1, e2 
        if e1 in entity2line: 
            entity2line[e1] += line + '\n'
        else: 
            entity2line[e1] = line + '\n'
        if e2 in entity2line: 
            entity2line[e2] += line + '\n'
        else: 
            entity2line[e2] = line + '\n'
        if e1 in entity2count: 
            entity2count[e1] += 1 
        else:
            entity2count[e1] = 1 
        if e2 in entity2count: 
            entity2count[e2] += 1 
        else:
            entity2count[e2] = 1 
    return entity2count, entity2line 

def get_other_entity(entity, line): 
    words = line.split('\t') 
    e1 = words[1] 
    e2 = words[2] 
    if e1 == entity: 
        return e2
    if e2 == entity: 
        return e1 
    

def get_neighbor_w_highest_neighbor(entity, entity2count, entity2line): 
    sub_e2c = {} 
    global entity_considered 
    if debug >= 1: 
        print 'neighbors to consider' 
    for line in entity2line[entity].split('\n'): 
        if line.strip() == '': 
            continue 
        other = get_other_entity(entity, line) 
        if debug >= 1: 
            print other, entity2count[other] 
        sub_e2c[other] = entity2count[other] 

    for each in sorted(sub_e2c.iteritems(), key=operator.itemgetter(1), reverse=True):      
        if not re.search('#'+each[0]+'#', entity_considered):
            if debug >= 1: 
                print 'returning', each[0], 'with count', each[1] 
            return each[0] 
    return '' 
        
def traverse_relations(entity, entity2count, entity2line): 
    global entity_considered 
    global relations_considered 
    if debug >= 1: 
        print 'entity considered', entity 
        print 'relations considered:'
    for line in entity2line[entity].split('\n'): 
        if not re.search(line, relations_considered): 
            if debug >= 1: 
                print line 
            relations_considered += line + '\n' 
    next = get_neighbor_w_highest_neighbor(entity, entity2count, entity2line)
    if next == '': 
        return 
    entity_considered += '#'+next+'#\n'
    traverse_relations(next, entity2count, entity2line)

def sort_with_weight(): 
    global relations_considered 
    global entity_considered 
    weight2relations = {} 
    sorted_relations = '' 
    for line in weight_for_relation.split('\n'): 
        if line.strip() == '': 
            continue 
        words = line.split('\t') 
        if len(words) < 6: 
            continue 
        if debug >= 2: 
            print words 

        if debug >= 2: 
            print words[5] 
        if float(words[5]) in weight2relations: 
            weight2relations[float(words[5])] += line + '\n' 
        else:
            weight2relations[float(words[5])] = line + '\n' 

    for key in sorted(weight2relations.iterkeys(), reverse=True):
        if debug >= 1: 
            print key 
        entity_considered = '' 
        entity2count, entity2line = get_entity_count(weight2relations[key]) 
        for each in sorted(entity2count.iteritems(), key=operator.itemgetter(1), reverse=True):  
            if not re.search('#'+each[0]+'#', entity_considered):
                entity_considered += '#'+each[0]+'#\n'
                traverse_relations(each[0], entity2count, entity2line) 

    if debug >= 0: 
        print relations_considered 
    sorted_weight.write(relations_considered) 
    
    if debug >= 2: 
        print len(weight_for_relation.split('\n')), len(relations_considered.split('\n')), equal_count

sort_with_weight() 
sorted_weight.close() 
