#!/usr/bin/python 

import os 
import re
import sys 
import math
import commands 

def get_arg(index):
    return sys.argv[index]

debug = 1

input_file = get_arg(1) 
text = open(input_file).read() 

class SCORE(): 
    def __init__(self): 
        self.event_p = 0 
        self.event_r = 0 
        self.event_f1 = 0 
        self.event_class = 0 
        self.timex_p = 0
        self.timex_r = 0 
        self.timex_f1 = 0
        self.timex_st_f1 = 0 
        self.timex_value = 0 
        self.timex_type = 0 
        self.count = 0 
        self.relation_p = 0
        self.relation_r = 0
        self.relation_f1 = 0

def get_scores(split_text): 
    score = SCORE() 
    if debug >= 2: 
        print split_text[0] 
        print split_text[1] 
    foo = split_text[1].split('\t') 
    score.relation_p = float(foo[1])
    score.relation_r = float(foo[2]) 
    score.relation_f1 = float(foo[3])
    if debug >= 2: 
        print score.relation_p, score.relation_r, score.relation_f1 
        print split_text[2] 
        print split_text[3]     
    foo = split_text[3].split('\t') 
    score.event_p = float(foo[1])
    score.event_r = float(foo[2])    
    score.event_f1 = float(foo[3])
    score.event_class = float(foo[4])
    if debug >= 2:  
        print score.event_p, score.event_r, score.event_f1, score.event_class 
        print split_text[5] 
        print split_text[6] 
    foo = split_text[6].split('\t') 
    score.timex_p = float(foo[1]) 
    score.timex_r = float(foo[2])
    score.timex_f1 = float(foo[3]) 
    score.timex_st_f1 = float(foo[4])
    score.timex_value = float(foo[5]) 
    score.timex_type = float(foo[6])
    if debug >= 2: 
        print score.timex_p, score.timex_r, score.timex_f1, score.timex_st_f1, score.timex_value, score.timex_type 
    return score 
    

def add_score(score, score2): 
    score.relation_p += score2.relation_p
    score.relation_r += score2.relation_r
    score.relation_f1 += score2.relation_f1
    score.event_p += score2.event_p
    score.event_r += score2.event_r
    score.event_f1 += score2.event_f1
    score.event_class += score2.event_class
    score.timex_p += score2.timex_p
    score.timex_r += score2.timex_r
    score.timex_f1 += score2.timex_f1
    score.timex_st_f1 += score2.timex_st_f1
    score.timex_value += score2.timex_value
    score.timex_type += score2.timex_type
    return score 

def print_score(system, score, fold_count, fold_print): 
    print fold_print +'\t'+ system +'\t'+ str(round(score.relation_p*100.0/fold_count, 2)) +'\t'+ str(round(score.relation_r*100.0/fold_count, 2)) +'\t'+ str(round(score.relation_f1*100.0/fold_count, 2)) +'\t'+ str(round(score.event_p*100.0/fold_count, 1)) +'\t'+ str(round(score.event_r*100.0/fold_count, 1)) +'\t'+ str(round(score.event_f1*100.0/fold_count, 1)) +'\t'+ str(round(score.event_class*100.0/fold_count, 1)) +'\t' + str(round((score.event_r*100.0/fold_count)*(score.event_class*1.0/fold_count), 1)) +'\t'+ str(round(score.timex_p*100.0/fold_count, 1)) +'\t'+ str(round(score.timex_r*100.0/fold_count, 1)) +'\t'+ str(round(score.timex_f1*100.0/fold_count, 1)) +'\t'+ str(round(score.timex_st_f1*100.0/fold_count, 1)) +'\t'+ str(round(score.timex_value*100.0/fold_count, 1)) +'\t'+ str(round((score.timex_r*100.0/fold_count)*(score.timex_value*1.0/fold_count), 1)) +'\t'+ str(round((score.timex_r*100.0/fold_count)*(score.timex_type*1.0/fold_count), 1))
    
def parse_10fold(): 
    all_systems = {}     
    system_list = '' 
    fold_count = 0 
    print 'Fold' +'\t'+ 'System' +'\t'+ 'P' +'\t'+ 'R\tF1' +'\t'+ 'eventP'+ '\t'+ 'eventR' +'\t'+ 'eventF1' +'\t'+ 'class A\tclass R' +'\t'+ 'timexP' +'\t'+ 'timexR' +'\t'+ 'timexF1' +'\t'+ 'ST_F1' +'\t'+ 'value A\tvalue R' +'\t'+ 'TYPE' 
    for fold in text.split('### '): 
        fold_count +=1 
        if fold.strip() == '': 
            continue  
        systems = fold.split('>> ')
        fold_number = re.sub('----------------------------------------', '', systems[0]).strip() 
        if debug >= 2: 
            print 'fold_number', fold_number 
        for i in range(1, len(systems)):         
            lines = systems[i].split('\n') 
            if debug >= 2:
                print '$$$$' 
            system = re.sub('----------------------------------------', '', lines[0]) 
            system = re.sub(fold_number, '', system).strip()  
            if not re.search('#'+system+'#', system_list): 
                system_list += '#'+system+'#'+'\n' 

            if debug >= 2:
                print 'system', system
            score = get_scores(lines[1:]) 

#           if system == 'top-down-per-best': 
#            if system == 'TIPSem': 
#                print_score(system, score, 1, fold_number) 
            if not system in all_systems: 
                all_systems[system] = score 
            else: 
                all_systems[system] = add_score(all_systems[system], score) 
            
    fold_count -=1 
    for system in system_list.split('\n'): 
        system = re.sub('#', '', system) 
        if system.strip() == '': 
            continue 
        score = all_systems[system]
#        if system == 'top-down-per-best' or system == 'TIPSem':# or system == 'top-down-111-ignore': 
        if system != 'top-down-union': 
            print_score(system, score, fold_count, 'AVG')

        
parse_10fold() 
        
