# this program parses the task results 

import re
import operator

text = open('ABC.txt').read() 


def parse_result(heading, results): 
	heading_split = heading.split('\t')
	results_split = results.split('\t')
	#print heading_split, results_split 
	heading2result = {} 
	for i in range(1, len(heading_split)): 	
		#print i, heading_split[i], results_split[i+1]
		heading2result[heading_split[i]] = results_split[i+1]
	return heading_split[0], heading2result 
	
	
def get_participant_info(info): 
	info = re.sub('TE3-platinum-test-runs/', '', info)
	info = re.sub('/', '-', info)
	change_participant = {'TE3-test-key-key':'KEY', 'Stanford-SUTime':'SUTime', 'chambers-NavyTime1':'NavyTime-1', 'chambers-NavyTime2':'NavyTime-2', 'unihd-english-3':'HeidelTime-t', 'cleartk-2-timebank-verbclause':'cleartk-2', 'cleartk-1-timebank':'cleartk-1', 'manchester_filannino-run4':'ManTIME-4', 'manchester_filannino-run2':'ManTIME-2', 'cleartk-4-timebank-aquaint-inferences':'cleartk-4', 'cleartk-3-timebank-aquaint':'cleartk-3', 'manchester_filannino-run6':'ManTIME-6', 'unihd-english-2':'HeidelTime-bf', 'manchester_filannino-run1':'ManTIME-1', 'manchester_filannino-run5':'ManTIME-5', 'manchester_filannino-run3':'ManTIME-3', 'unihd-english-1':'HeidelTime-1.2', 'Jung-and-Stent-at-ATT-ATT1':'ATT-1', 'Jung-and-Stent-at-ATT-ATT2':'ATT-2', 'jrc-optima-run1_English':'FSS-TimEx', 'TIPSem-key':'TIPSem (TE2)', 'TIPSemB-key':'TIPSemB (TE2)', 'KUL-TE3Run1':'KUL-1', 'KUL-TE3RunAB':'KUL-2', 'Jung-and-Stent-at-ATT-ATT3':'ATT-3', 'temp-asooja-verma-B-ESAfeatureGold':'Temp:ESAfeature', 'temp-asooja-verma-B-WordNetfeatureGold':'Temp:WordNetfeature', 'anup_kolya-platinum':'JU-CSE'}
	if info in change_participant: 
		return change_participant[info]
	return info

def get_add_char(): 
	return ' & '
	
def read_results():
	teams = {} 
	all_tasks = [] 
	for team_run in text.split('data/'): 
		if team_run.strip() == '': 
			continue
		run_split = team_run.split('\n')
		participant_info = get_participant_info(run_split[0])
		##print '\nparticipant', participant_info
		participant_results = {} 
		for task in '\n'.join(run_split[1:]).split('=== '): 
			if task.strip() == '': 
				continue
			if re.search('INVALID INPUT FORMAT', task) or re.search('TEXTS NOT SAME', task): 
				print 'INVALID INPUT FORMAT', 'for', participant_info
				continue
##			print task 
			task_split = task.split('\n')
			task_name = re.sub('Performance ===', '', re.sub('Score ===', '', task_split[0])).strip()
			task_name = re.sub(' ', '_', task_name)
			if not task_name in all_tasks: 
				all_tasks.append(task_name)
			##print '$$', task_name
			for i in range(1, len(task_split)): 
				line = task_split[i]
				if line.strip() == '': 
					continue
				if not re.search('[a-zA-Z]', line): 
					continue
				if re.search('Overall Temporal Awareness Score', line): 
					continue
				heading, heading2result = parse_result(task_split[i], task_split[i+1])
				##print heading, heading2result 
				for each in heading2result: 
					index = task_name + '-' + heading + '-' + each 
					index = re.sub(' ', '_', index)
					participant_results[index] = heading2result[each]
			## if task == event , timex , relations, store accordingly 
		##print participant_results
		teams[participant_info] = participant_results
	print all_tasks
	for task in all_tasks: 
		print ''
		print task 
		team2results = {} 
		team2attribute = {} 
		team2F1 = {} 
		team2attrF1 = {} 
		for participant in teams: 
			#print participant 
			participant_results = teams[participant] 
			if task == 'Temporal_Awareness': 
				try:
					entity = participant + get_add_char() +  "{0:0.2f}".format(float(participant_results['Temporal_Awareness-Temporal_Score-F1'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Temporal_Awareness-Temporal_Score-P'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Temporal_Awareness-Temporal_Score-R'])) 
					team2results[participant] = entity
					team2F1[participant] = float(participant_results['Temporal_Awareness-Temporal_Score-F1'])
					
				except: 
					a = 1 
			if task == 'Timex': 
				try: 
					entity = participant + get_add_char() +  "{0:0.2f}".format(float(participant_results['Timex-Relaxed_Match-F1'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Timex-Relaxed_Match-P'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Timex-Relaxed_Match-R'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Timex-Strict_Match-F1'])) 
					team2results[participant] = entity
					team2F1[participant] = float(participant_results['Timex-Relaxed_Match-F1'])
					attribute = participant + get_add_char() + "{0:0.2f}".format(float(participant_results['Timex-Attribute_F1-Value'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Timex-Attribute_F1-Type']))
					team2attribute[participant] = attribute 
					team2attrF1[participant] = float(participant_results['Timex-Attribute_F1-Value'])
				except: 
					a = 1	

			if task == 'Event': 
				try:
					entity = participant + get_add_char() +  "{0:0.2f}".format(float(participant_results['Event-Relaxed_Match-F1'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Event-Relaxed_Match-P'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Event-Relaxed_Match-R'])) 
					team2results[participant] = entity
					team2F1[participant] = float(participant_results['Event-Relaxed_Match-F1'])
					attribute = participant + get_add_char() + "{0:0.2f}".format(float(participant_results['Event-Attribute_F1-Class'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Event-Attribute_F1-Tense'])) + get_add_char() + "{0:0.2f}".format(float(participant_results['Event-Attribute_F1-Aspect']))  
					team2attribute[participant] = attribute 
					team2attrF1[participant] = float(participant_results['Event-Attribute_F1-Class'])
				except: 
					a = 1 


		if task == 'Timex': 
			heading = 'System' + get_add_char() + 'F1' + get_add_char() + 'P' + get_add_char() + 'R' + get_add_char() + 'Strict F1'
			print heading
			sorted_x = sorted(team2F1.iteritems(), key=operator.itemgetter(1), reverse=True)
			for each in sorted_x: 
				print team2results[each[0]] + ' \\\\'
				print '\hline'
				
			print '\nTimex Attribute'
			heading = 'System' + get_add_char() + 'Value F1' + get_add_char() + 'Type F1' 
			print heading
			sorted_x = sorted(team2attrF1.iteritems(), key=operator.itemgetter(1), reverse=True)
			for each in sorted_x: 
				print team2attribute[each[0]] + ' \\\\'
				print '\hline'
			
				
		if task == 'Event': 
			heading = 'System' + get_add_char() + 'F1' + get_add_char() + 'P' + get_add_char() + 'R' + get_add_char() 
			print heading
			sorted_x = sorted(team2F1.iteritems(), key=operator.itemgetter(1), reverse=True)
			for each in sorted_x: 
				print team2results[each[0]] + ' \\\\'
				print '\hline'
				
			print '\nEvent Attribute'
			heading = 'System' + get_add_char() + 'Class F1' + get_add_char() + 'Tense F1' + get_add_char() + 'Aspect F1' + get_add_char() 
			print heading
			sorted_x = sorted(team2attrF1.iteritems(), key=operator.itemgetter(1), reverse=True)
			for each in sorted_x: 
				print team2attribute[each[0]] + ' \\\\'
				print '\hline'
			
		if task == 'Temporal_Awareness': 
			heading = 'System' + get_add_char() + 'F1' + get_add_char() + 'P' + get_add_char() + 'R' + get_add_char() 
			print heading
			sorted_x = sorted(team2F1.iteritems(), key=operator.itemgetter(1), reverse=True)
			for each in sorted_x: 
				print team2results[each[0]] + ' \\\\'
				print '\hline'
			
		
read_results()